package service

import (
	"XT_New/models"
	"fmt"
	"github.com/jinzhu/gorm"
	"time"
)

// func GetSchedualPatients(orgID int64) ([]*MDialysisScheduleVM, error) {
// 	var vms []*MDialysisScheduleVM
// 	err := readDb.
// 		Table("xt_schedule as sch").
// 		Preload("SchedualPatient", "status = 1 AND user_org_id = ?", orgID).
// 		Preload("DeviceNumber", "status = 1 AND org_id = ?", orgID).
// 		Preload("DeviceZone", "status = 1 AND org_id = ?", orgID).
// 		Preload("TreatmentMode", "status = 1").
// 		Preload("DialysisOrder", "status = 1 AND user_org_id = ?", orgID).
// 		Preload("DialysisOrder.MonitoringRecords", "status = 1 AND user_org_id = ?", orgID).
// 		Where("sch.status = 1 AND sch.user_org_id = ? AND schedule_date = 1536768000", orgID).
// 		Find(&vms).
// 		Error
// 	return vms, err
// }

func MobileGetDialysisScheduals(orgID int64, scheduleDate int64, scheduleType int64) ([]*MDialysisScheduleVM, error) {
	var vms []*MDialysisScheduleVM
	db := readDb.
		Table("xt_schedule as sch").
		Preload("SchedualPatient", "status = 1 AND user_org_id = ?", orgID).
		Preload("DeviceNumber", "status = 1 AND org_id = ?", orgID).
		Preload("DeviceNumber.Zone", "status = 1 AND org_id = ?", orgID).
		Preload("TreatmentMode", "status = 1").
		Preload("Advices", "status = 1 AND user_org_id = ? AND advice_type = 2", orgID).
		Preload("Prescription", "status = 1 AND user_org_id = ? AND record_date = ?", orgID, scheduleDate).
		Preload("AssessmentBeforeDislysis", "status = 1 AND user_org_id = ? AND assessment_date = ? ", orgID, scheduleDate).
		Preload("DialysisOrder", "status = 1 AND user_org_id = ?", orgID).
		Preload("DialysisOrder.DeviceNumber", "status = 1 AND org_id = ?", orgID).
		// Preload("DialysisOrder.MonitoringRecords", func(rdb *gorm.DB) *gorm.DB {
		// 	return rdb.Where("status = 1 AND user_org_id = ?", orgID).Order("operate_time DESC")
		// }).
		Where("sch.status = 1 AND sch.user_org_id = ?", orgID)
	if scheduleDate != 0 {
		db = db.Where("schedule_date = ?", scheduleDate)
	}
	if scheduleType != 0 {
		db = db.Where("schedule_type = ?", scheduleType)
	}

	err := db.Find(&vms).Error
	return vms, err
}

func MobileGetWaitingScheduals(orgID int64, scheduleDate int64) ([]*MDialysisScheduleVM, error) {
	var vms []*MDialysisScheduleVM
	db := readDb.
		Table("xt_schedule as sch").
		Preload("SchedualPatient", "status = 1 AND user_org_id = ?", orgID).
		Preload("DeviceNumber", "status = 1 AND org_id = ?", orgID).
		Preload("DeviceNumber.Zone", "status = 1 AND org_id = ?", orgID).
		// Preload("DeviceZone", "status = 1 AND org_id = ?", orgID).
		Preload("TreatmentMode", "status = 1").
		Preload("Prescription", "status = 1 AND user_org_id = ? AND record_date = ?", orgID, scheduleDate).
		Preload("AssessmentBeforeDislysis", "status = 1 AND user_org_id = ? AND assessment_date = ? ", orgID, scheduleDate).
		Preload("DialysisOrder", "status = 1 AND user_org_id = ?", orgID).
		Preload("Advices", "status = 1 AND user_org_id = ? AND advice_type = 2 ", orgID).
		Where("sch.status = 1 AND sch.user_org_id = ?", orgID)
	if scheduleDate != 0 {
		db = db.Where("schedule_date = ?", scheduleDate)
	}

	err := db.Find(&vms).Error
	return vms, err
}

type MDialysisScheduleVM struct {
	ID           int64 `gorm:"column:id" json:"id"`
	UserOrgId    int64 `gorm:"column:user_org_id" json:"user_org_id"`
	PartitionId  int64 `gorm:"column:partition_id" json:"partition_id"`
	BedId        int64 `gorm:"column:bed_id" json:"bed_id"`
	PatientId    int64 `gorm:"column:patient_id" json:"patient_id"`
	ScheduleDate int64 `gorm:"column:schedule_date" json:"schedule_date"`
	ScheduleType int64 `gorm:"column:schedule_type" json:"schedule_type"`
	ModeId       int64 `gorm:"column:mode_id" json:"mode_id"`
	Status       int64 `gorm:"column:status" json:"status"`

	SchedualPatient          *MSchedualPatientVMList           `gorm:"ForeignKey:PatientId" json:"patient"`
	DeviceNumber             *MDeviceNumberVM                  `gorm:"ForeignKey:BedId" json:"device_number"`
	DeviceZone               *models.DeviceZone                `gorm:"ForeignKey:PartitionId" json:"device_zone"`
	TreatmentMode            *models.TreatmentMode             `gorm:"ForeignKey:ModeId" json:"treatment_mode"`
	DialysisOrder            *MDialysisOrderVMList             `gorm:"ForeignKey:DialysisDate,PatientId;AssociationForeignKey:ScheduleDate,PatientId" json:"dialysis_order"`
	Prescription             *models.DialysisPrescriptionList  `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"prescription"`
	AssessmentBeforeDislysis *models.PredialysisEvaluationList `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"assessment_before_dislysis"`
	Advices                  []*models.DoctorAdvice            `gorm:"ForeignKey:AdviceDate,PatientId;AssociationForeignKey:ScheduleDate,PatientId" json:"doctor_advice"`
}

func (MDialysisScheduleVM) TableName() string {
	return "xt_schedule"
}

type MDeviceNumberVM struct {
	models.DeviceNumber

	Zone *models.DeviceZone `gorm:"ForeignKey:ZoneID" json:"zone"`
}

func (MDeviceNumberVM) TableName() string {
	return "xt_device_number"
}

type MSchedualPatientVMList struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId      int64  `gorm:"column:user_id" json:"user_id" form:"user_id"`
	PatientType int64  `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	Avatar      string `gorm:"column:avatar" json:"avatar" form:"avatar"`
	Gender      int64  `gorm:"column:gender" json:"gender" form:"gender"`
	Birthday    int64  `gorm:"column:birthday" json:"birthday" form:"birthday"`
	Age         int64  `gorm:"column:age" json:"age"`
	Name        string `gorm:"column:name" json:"name" form:"name"`
}

func (MSchedualPatientVMList) TableName() string {
	return "xt_patients"
}

type MSchedualPatientVM struct {
	ID                      int64   `gorm:"column:id" json:"id" form:"id"`
	UserOrgId               int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId                  int64   `gorm:"column:user_id" json:"user_id" form:"user_id"`
	PatientType             int64   `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	Avatar                  string  `gorm:"column:avatar" json:"avatar" form:"avatar"`
	DialysisNo              string  `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	AdmissionNumber         string  `gorm:"column:admission_number" json:"admission_number" form:"admission_number"`
	Source                  int64   `gorm:"column:source" json:"source" form:"source"`
	Lapseto                 int64   `gorm:"column:lapseto" json:"lapseto" form:"lapseto"`
	PartitionId             int64   `gorm:"column:partition_id" json:"partition_id" form:"partition_id"`
	BedId                   int64   `gorm:"column:bed_id" json:"bed_id" form:"bed_id"`
	Name                    string  `gorm:"column:name" json:"name" form:"name"`
	Alias                   string  `gorm:"column:alias" json:"alias" form:"alias"`
	Gender                  int64   `gorm:"column:gender" json:"gender" form:"gender"`
	Nation                  string  `gorm:"column:nation" json:"nation" form:"nation"`
	NativePlace             string  `gorm:"column:native_place" json:"native_place" form:"native_place"`
	MaritalStatus           int64   `gorm:"column:marital_status" json:"marital_status" form:"marital_status"`
	IdCardNo                string  `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Birthday                int64   `gorm:"column:birthday" json:"birthday" form:"birthday"`
	ReimbursementWayId      int64   `gorm:"column:reimbursement_way_id" json:"reimbursement_way_id" form:"reimbursement_way_id"`
	HealthCareType          int64   `gorm:"column:health_care_type" json:"health_care_type" form:"health_care_type"`
	HealthCareNo            string  `gorm:"column:health_care_no" json:"health_care_no" form:"health_care_no"`
	HealthCareDueDate       int64   `gorm:"column:health_care_due_date" json:"health_care_due_date" form:"health_care_due_date"`
	Height                  int64   `gorm:"column:height" json:"height" form:"height"`
	BloodType               int64   `gorm:"column:blood_type" json:"blood_type" form:"blood_type"`
	Rh                      int64   `gorm:"column:rh" json:"rh" form:"rh"`
	HealthCareDueAlertDate  int64   `gorm:"column:health_care_due_alert_date" json:"health_care_due_alert_date" form:"health_care_due_alert_date"`
	EducationLevel          int64   `gorm:"column:education_level" json:"education_level" form:"education_level"`
	Profession              int64   `gorm:"column:profession" json:"profession" form:"profession"`
	Phone                   string  `gorm:"column:phone" json:"phone" form:"phone"`
	HomeTelephone           string  `gorm:"column:home_telephone" json:"home_telephone" form:"home_telephone"`
	RelativePhone           string  `gorm:"column:relative_phone" json:"relative_phone" form:"relative_phone"`
	RelativeRelations       string  `gorm:"column:relative_relations" json:"relative_relations" form:"relative_relations"`
	HomeAddress             string  `gorm:"column:home_address" json:"home_address" form:"home_address"`
	WorkUnit                string  `gorm:"column:work_unit" json:"work_unit" form:"work_unit"`
	UnitAddress             string  `gorm:"column:unit_address" json:"unit_address" form:"unit_address"`
	Children                int64   `gorm:"column:children" json:"children" form:"children"`
	ReceivingDate           int64   `gorm:"column:receiving_date" json:"receiving_date" form:"receiving_date"`
	IsHospitalFirstDialysis int64   `gorm:"column:is_hospital_first_dialysis" json:"is_hospital_first_dialysis" form:"is_hospital_first_dialysis"`
	FirstDialysisDate       int64   `gorm:"column:first_dialysis_date" json:"first_dialysis_date" form:"first_dialysis_date"`
	FirstDialysisHospital   string  `gorm:"column:first_dialysis_hospital" json:"first_dialysis_hospital" form:"first_dialysis_hospital"`
	InductionPeriod         int64   `gorm:"column:induction_period" json:"induction_period" form:"induction_period"`
	InitialDialysis         int64   `gorm:"column:initial_dialysis" json:"initial_dialysis" form:"initial_dialysis"`
	TotalDialysis           int64   `gorm:"column:total_dialysis" json:"total_dialysis" form:"total_dialysis"`
	AttendingDoctorId       int64   `gorm:"column:attending_doctor_id" json:"attending_doctor_id" form:"attending_doctor_id"`
	HeadNurseId             int64   `gorm:"column:head_nurse_id" json:"head_nurse_id" form:"head_nurse_id"`
	Evaluate                string  `gorm:"column:evaluate" json:"evaluate" form:"evaluate"`
	Diagnose                string  `gorm:"column:diagnose" json:"diagnose" form:"diagnose"`
	Remark                  string  `gorm:"column:remark" json:"remark" form:"remark"`
	RegistrarsId            int64   `gorm:"column:registrars_id" json:"registrars_id" form:"registrars_id"`
	Registrars              string  `gorm:"column:registrars" json:"registrars" form:"registrars"`
	QrCode                  string  `gorm:"column:qr_code" json:"qr_code" form:"qr_code"`
	BindingState            int64   `gorm:"column:binding_state" json:"binding_state" form:"binding_state"`
	PatientComplains        string  `gorm:"column:patient_complains" json:"patient_complains"` // 主诉
	PresentHistory          string  `gorm:"column:present_history" json:"present_history"`     // 现病史
	PastHistory             string  `gorm:"column:past_history" json:"past_history"`           // 既往史
	Temperature             float64 `gorm:"column:temperature" json:"temperature"`             // 体格检查-体温
	Pulse                   int64   `gorm:"column:pulse" json:"pulse"`                         // 体格检查-脉搏
	Respiratory             int64   `gorm:"column:respiratory" json:"respiratory"`             // 体格检查-呼吸频率
	SBP                     int64   `gorm:"column:sbp" json:"sbp"`                             // 体格检查-收缩压
	DBP                     int64   `gorm:"column:dbp" json:"dbp"`                             // 体格检查-舒张压
	Status                  int64   `gorm:"column:status" json:"status" form:"status"`
	Age                     int64   `gorm:"column:age" json:"age"`
	IsOpenRemind            int64   `gorm:"column:is_open_remind" json:"is_open_remind"`
	DialysisAge             int64   `gorm:"column:dialysis_age" json:"dialysis_age" form:"dialysis_age"`
	ExpenseKind             int64   `gorm:"column:expense_kind" json:"expense_kind" form:"expense_kind"`
	TellPhone               string  `gorm:"column:tell_phone" json:"tell_phone" form:"tell_phone"`
	FirstTreatmentDate      int64   `gorm:"column:first_treatment_date" json:"first_treatment_date" form:"first_treatment_date"`
	ContactName             string  `gorm:"column:contact_name" json:"contact_name" form:"contact_name"`
}

func (MSchedualPatientVM) TableName() string {
	return "xt_patients"
}

type MDialysisOrderVM struct {
	ID           int64 `gorm:"column:id" json:"id"`
	DialysisDate int64 `gorm:"column:dialysis_date" json:"dialysis_date"`
	UserOrgId    int64 `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId    int64 `gorm:"column:patient_id" json:"patient_id"`
	// PrescriptionId int64  `gorm:"column:prescription_id" json:"prescription_id"`
	Stage int64 `gorm:"column:stage" json:"stage"`
	// Remark         string `gorm:"column:remark" json:"remark"`
	BedID             int64                      `gorm:"column:bed_id" json:"bed_id"`
	StartNurse        int64                      `gorm:"column:start_nurse" json:"start_nurse"`
	FinishNurse       int64                      `gorm:"column:finish_nurse" json:"finish_nurse"`
	Status            int64                      `gorm:"column:status" json:"status"`
	PunctureNurse     int64                      `gorm:"column:puncture_nurse" json:"puncture_nurse"`
	DeviceNumber      *MDeviceNumberVM           `gorm:"ForeignKey:BedID" json:"device_number"`
	MonitoringRecords []*models.MonitoringRecord `gorm:"ForeignKey:DialysisOrderId" json:"monitoring_records"`
	Creator           int64                      `gorm:"column:creator" json:"creator"`
	Modifier          int64                      `gorm:"column:modifier" json:"modifier"`
	FinishCreator     int64                      `gorm:"column:finish_creator" json:"finish_creator"`
	FinishModifier    int64                      `gorm:"column:finish_modifier" json:"finish_modifier"`
	SchedualType      int64                      `gorm:"column:schedual_type" json:"schedual_type"`
}

func (MDialysisOrderVM) TableName() string {
	return "xt_dialysis_order"
}

type MDialysisOrderVMList struct {
	ID           int64 `gorm:"column:id" json:"id"`
	DialysisDate int64 `gorm:"column:dialysis_date" json:"dialysis_date"`
	UserOrgId    int64 `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId    int64 `gorm:"column:patient_id" json:"patient_id"`
	// PrescriptionId int64  `gorm:"column:prescription_id" json:"prescription_id"`
	Stage int64 `gorm:"column:stage" json:"stage"`
	// Remark         string `gorm:"column:remark" json:"remark"`
	BedID          int64            `gorm:"column:bed_id" json:"bed_id"`
	StartNurse     int64            `gorm:"column:start_nurse" json:"start_nurse"`
	FinishNurse    int64            `gorm:"column:finish_nurse" json:"finish_nurse"`
	Status         int64            `gorm:"column:status" json:"status"`
	PunctureNurse  int64            `gorm:"column:puncture_nurse" json:"puncture_nurse"`
	DeviceNumber   *MDeviceNumberVM `gorm:"ForeignKey:BedID" json:"device_number"`
	Creator        int64            `gorm:"column:creator" json:"creator"`
	Modifier       int64            `gorm:"column:modifier" json:"modifier"`
	FinishCreator  int64            `gorm:"column:finish_creator" json:"finish_creator"`
	FinishModifier int64            `gorm:"column:finish_modifier" json:"finish_modifier"`
	SchedualType   int64            `gorm:"column:schedual_type" json:"schedual_type"`
}

func (MDialysisOrderVMList) TableName() string {
	return "xt_dialysis_order"
}

// 获取透析记录
func MobileGetDialysisRecord(orgID int64, patientID int64, recordDate int64) (*models.DialysisOrder, error) {
	var record models.DialysisOrder
	err := readDb.Model(&models.DialysisOrder{}).Where("user_org_id = ? AND patient_id = ? AND dialysis_date = ?", orgID, patientID, recordDate).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 用户基本信息
func MobileGetPatientDetail(orgID int64, patientID int64) (*MPatient, error) {
	var patient MPatient
	err := readDb.Model(&MPatient{}).Where("status = 1 AND user_org_id = ? AND id = ?", orgID, patientID).First(&patient).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &patient, nil
}

// 用户排班信息
func MobileGetSchedualDetail(orgID int64, patientID int64, schedualDate int64) (*MDialysisScheduleVM, error) {
	var vm MDialysisScheduleVM
	err := readDb.
		Table("xt_schedule").
		// Preload("SchedualPatient", "status = 1 AND user_org_id = ?", orgID).
		Preload("DeviceNumber", "status = 1 AND org_id = ?", orgID).
		Where("status = 1 AND user_org_id = ? AND schedule_date = ? AND patient_id = ?", orgID, schedualDate, patientID).
		First(&vm).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &vm, err
}

// 用户排班信息
func MobileGetPatientSchedual(orgID int64, patientID int64, schedualDate int64) (*models.Schedule, error) {
	var schedule models.Schedule
	err := readDb.
		Table("xt_schedule").
		Where("status = 1 AND user_org_id = ? AND schedule_date = ? AND patient_id = ?", orgID, schedualDate, patientID).
		First(&schedule).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &schedule, nil
}

type MPatient struct {
	ID                      int64   `gorm:"column:id" json:"id" form:"id"`
	UserOrgId               int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId                  int64   `gorm:"column:user_id" json:"user_id" form:"user_id"`
	PatientType             int64   `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	Avatar                  string  `gorm:"column:avatar" json:"avatar" form:"avatar"`
	DialysisNo              string  `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	AdmissionNumber         string  `gorm:"column:admission_number" json:"admission_number" form:"admission_number"`
	Source                  int64   `gorm:"column:source" json:"source" form:"source"`
	Lapseto                 int64   `gorm:"column:lapseto" json:"lapseto" form:"lapseto"`
	PartitionId             int64   `gorm:"column:partition_id" json:"partition_id" form:"partition_id"`
	BedId                   int64   `gorm:"column:bed_id" json:"bed_id" form:"bed_id"`
	Name                    string  `gorm:"column:name" json:"name" form:"name"`
	Alias                   string  `gorm:"column:alias" json:"alias" form:"alias"`
	Gender                  int64   `gorm:"column:gender" json:"gender" form:"gender"`
	Nation                  string  `gorm:"column:nation" json:"nation" form:"nation"`
	NativePlace             string  `gorm:"column:native_place" json:"native_place" form:"native_place"`
	MaritalStatus           int64   `gorm:"column:marital_status" json:"marital_status" form:"marital_status"`
	IdCardNo                string  `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Birthday                int64   `gorm:"column:birthday" json:"birthday" form:"birthday"`
	ReimbursementWayId      int64   `gorm:"column:reimbursement_way_id" json:"reimbursement_way_id" form:"reimbursement_way_id"`
	HealthCareType          int64   `gorm:"column:health_care_type" json:"health_care_type" form:"health_care_type"`
	HealthCareNo            string  `gorm:"column:health_care_no" json:"health_care_no" form:"health_care_no"`
	HealthCareDueDate       int64   `gorm:"column:health_care_due_date" json:"health_care_due_date" form:"health_care_due_date"`
	Height                  int64   `gorm:"column:height" json:"height" form:"height"`
	BloodType               int64   `gorm:"column:blood_type" json:"blood_type" form:"blood_type"`
	Rh                      int64   `gorm:"column:rh" json:"rh" form:"rh"`
	HealthCareDueAlertDate  int64   `gorm:"column:health_care_due_alert_date" json:"health_care_due_alert_date" form:"health_care_due_alert_date"`
	EducationLevel          int64   `gorm:"column:education_level" json:"education_level" form:"education_level"`
	Profession              int64   `gorm:"column:profession" json:"profession" form:"profession"`
	Phone                   string  `gorm:"column:phone" json:"phone" form:"phone"`
	HomeTelephone           string  `gorm:"column:home_telephone" json:"home_telephone" form:"home_telephone"`
	RelativePhone           string  `gorm:"column:relative_phone" json:"relative_phone" form:"relative_phone"`
	RelativeRelations       string  `gorm:"column:relative_relations" json:"relative_relations" form:"relative_relations"`
	HomeAddress             string  `gorm:"column:home_address" json:"home_address" form:"home_address"`
	WorkUnit                string  `gorm:"column:work_unit" json:"work_unit" form:"work_unit"`
	UnitAddress             string  `gorm:"column:unit_address" json:"unit_address" form:"unit_address"`
	Children                int64   `gorm:"column:children" json:"children" form:"children"`
	ReceivingDate           int64   `gorm:"column:receiving_date" json:"receiving_date" form:"receiving_date"`
	IsHospitalFirstDialysis int64   `gorm:"column:is_hospital_first_dialysis" json:"is_hospital_first_dialysis" form:"is_hospital_first_dialysis"`
	FirstDialysisDate       int64   `gorm:"column:first_dialysis_date" json:"first_dialysis_date" form:"first_dialysis_date"`
	FirstDialysisHospital   string  `gorm:"column:first_dialysis_hospital" json:"first_dialysis_hospital" form:"first_dialysis_hospital"`
	InductionPeriod         int64   `gorm:"column:induction_period" json:"induction_period" form:"induction_period"`
	InitialDialysis         int64   `gorm:"column:initial_dialysis" json:"initial_dialysis" form:"initial_dialysis"`
	TotalDialysis           int64   `gorm:"column:total_dialysis" json:"total_dialysis" form:"total_dialysis"`
	AttendingDoctorId       int64   `gorm:"column:attending_doctor_id" json:"attending_doctor_id" form:"attending_doctor_id"`
	HeadNurseId             int64   `gorm:"column:head_nurse_id" json:"head_nurse_id" form:"head_nurse_id"`
	Evaluate                string  `gorm:"column:evaluate" json:"evaluate" form:"evaluate"`
	Diagnose                string  `gorm:"column:diagnose" json:"diagnose" form:"diagnose"`
	Remark                  string  `gorm:"column:remark" json:"remark" form:"remark"`
	RegistrarsId            int64   `gorm:"column:registrars_id" json:"registrars_id" form:"registrars_id"`
	Registrars              string  `gorm:"column:registrars" json:"registrars" form:"registrars"`
	QrCode                  string  `gorm:"column:qr_code" json:"qr_code" form:"qr_code"`
	BindingState            int64   `gorm:"column:binding_state" json:"binding_state" form:"binding_state"`
	PatientComplains        string  `gorm:"column:patient_complains" json:"patient_complains"` // 主诉
	PresentHistory          string  `gorm:"column:present_history" json:"present_history"`     // 现病史
	PastHistory             string  `gorm:"column:past_history" json:"past_history"`           // 既往史
	Temperature             float64 `gorm:"column:temperature" json:"temperature"`             // 体格检查-体温
	Pulse                   int64   `gorm:"column:pulse" json:"pulse"`                         // 体格检查-脉搏
	Respiratory             int64   `gorm:"column:respiratory" json:"respiratory"`             // 体格检查-呼吸频率
	SBP                     int64   `gorm:"column:sbp" json:"sbp"`                             // 体格检查-收缩压
	DBP                     int64   `gorm:"column:dbp" json:"dbp"`                             // 体格检查-舒张压
	Status                  int64   `gorm:"column:status" json:"status" form:"status"`
	Age                     int64   `gorm:"column:age" json:"age"`
	IsOpenRemind            int64   `gorm:"column:is_open_remind" json:"is_open_remind"`
	CreatedTime             int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	DialysisAge             int64   `gorm:"column:dialysis_age" json:"dialysis_age" form:"dialysis_age"`
	ExpenseKind             int64   `gorm:"column:expense_kind" json:"expense_kind" form:"expense_kind"`
	TellPhone               string  `gorm:"column:tell_phone" json:"tell_phone" form:"tell_phone"`
	FirstTreatmentDate      int64   `gorm:"column:first_treatment_date" json:"first_treatment_date" form:"first_treatment_date"`
	ContactName             string  `gorm:"column:contact_name" json:"contact_name" form:"contact_name"`
}

func (MPatient) TableName() string {
	return "xt_patients"
}

// 接诊评估
func MobileGetReceiverTreatmentAccessRecord(orgID int64, patientID int64, recordDate int64) (*models.ReceiveTreatmentAsses, error) {
	var record models.ReceiveTreatmentAsses
	err = readDb.Model(&models.ReceiveTreatmentAsses{}).Where("patient_id = ? and user_org_id = ? and status = 1 and record_date = ?", patientID, orgID, recordDate).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 透前评估
func MobileGetPredialysisEvaluation(orgID int64, patientID int64, recordDate int64) (*models.PredialysisEvaluation, error) {
	fmt.Println("recordDate", recordDate)
	var record models.PredialysisEvaluation
	err := readDb.Model(&models.PredialysisEvaluation{}).Where("patient_id = ? and user_org_id = ? and status = 1 and assessment_date = ?", patientID, orgID, recordDate).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 获取 maxDate 之前一次的透前评估记录
func MobileGetLastTimePredialysisEvaluation(orgID int64, patientID int64, maxDate int64) (*models.PredialysisEvaluation, error) {
	var record models.PredialysisEvaluation
	err := readDb.Model(&models.PredialysisEvaluation{}).Where("patient_id = ? and user_org_id = ? and status = 1 and assessment_date < ?", patientID, orgID, maxDate).Order("assessment_date desc").First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 临时医嘱
func MobileGetDoctorAdvices(orgID int64, patientID int64, recordDate int64) ([]*models.DoctorAdvice, error) {
	var records []*models.DoctorAdvice
	// err := readDb.Model(&models.DoctorAdvice{}).Where("patient_id = ? and user_org_id = ? and status = 1 and record_date = ?", patientID, orgID, recordDate).Find(&records).Error

	err := readDb.
		Model(&models.DoctorAdvice{}).
		Where("patient_id = ? and user_org_id = ? and status = 1 and record_date = ? and advice_type = 2", patientID, orgID, recordDate).
		Select("id,user_org_id,patient_id,advice_type,advice_date,record_date,start_time,advice_name,advice_desc,reminder_date, drug_spec, drug_spec_unit,single_dose,single_dose_unit,prescribing_number,prescribing_number_unit,delivery_way,execution_frequency,advice_doctor,status,created_time,updated_time,advice_affirm,remark,stop_time,stop_reason,stop_doctor,stop_state,parent_id,execution_time,execution_staff,execution_state,checker, check_state, check_time,IF(parent_id>0, parent_id, id) as advice_order,groupno").
		Order("start_time asc, groupno desc, advice_order desc, id").
		Scan(&records).Error

	if err != nil {
		return nil, err
	}
	return records, nil
}

func MobileGetDoctorAdvicesByGroups(orgID int64, patientID int64, recordDate int64) ([]*models.DoctorAdvice, error) {
	var records []*models.DoctorAdvice
	// err := readDb.Model(&models.DoctorAdvice{}).Where("patient_id = ? and user_org_id = ? and status = 1 and record_date = ?", patientID, orgID, recordDate).Find(&records).Error

	err := readDb.
		Model(&models.DoctorAdvice{}).
		Where("patient_id = ? and user_org_id = ? and status = 1 and record_date = ? and advice_type = 2", patientID, orgID, recordDate).
		Select("id, user_org_id, patient_id, advice_type, advice_date, record_date, start_time, advice_name,advice_desc, reminder_date, drug_spec, drug_spec_unit, single_dose, single_dose_unit, prescribing_number, prescribing_number_unit, delivery_way, execution_frequency, advice_doctor, status, created_time,updated_time, advice_affirm, remark, stop_time, stop_reason, stop_doctor, stop_state, parent_id, execution_time, execution_staff, execution_state, checker, check_state, check_time, groupno, IF(parent_id > 0, parent_id, id) as advice_order").
		Order("start_time asc, groupno desc, advice_order desc, id asc").
		Scan(&records).Error

	if err != nil {
		return nil, err
	}
	return records, nil
}

// 透析记录
func MobileGetSchedualDialysisRecord(orgID int64, patientID int64, recordDate int64) (*models.DialysisOrder, error) {
	var record models.DialysisOrder
	err := readDb.Model(&models.DialysisOrder{}).Preload("DeviceNumber", "org_id = ? AND  status = 1", orgID).Where("user_org_id = ? AND patient_id = ? AND  dialysis_date = ?", orgID, patientID, recordDate).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 双人核对
func MobileGetDoubleCheck(orgID int64, patientID int64, recordDate int64) (*models.DoubleCheck, error) {
	var record models.DoubleCheck
	err := readDb.Model(&models.DoubleCheck{}).Where("patient_id = ? and user_org_id = ? and status = 1 and check_date = ?", patientID, orgID, recordDate).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 透析监测记录
func MobileGetMonitorRecords(orgID int64, patientID int64, recordDate int64) ([]*models.MonitoringRecord, error) {
	var records []*models.MonitoringRecord
	err := readDb.Model(&models.MonitoringRecord{}).Where("patient_id = ? and user_org_id = ? and status = 1 and monitoring_date = ?", patientID, orgID, recordDate).Order("operate_time asc").Find(&records).Error
	if err != nil {
		return nil, err
	}
	return records, nil
}

func MobileGetMonitorRecordFirst(orgID int64, patientID int64, recordDate int64) (*models.MonitoringRecord, error) {
	var records models.MonitoringRecord
	err := readDb.Model(&models.MonitoringRecord{}).Where("patient_id = ? and user_org_id = ? and status = 1 and monitoring_date = ?", patientID, orgID, recordDate).Order("operate_time asc").First(&records).Error
	if err != nil {
		return nil, err
	}
	return &records, nil
}

func MobileGetLastMonitorRecord(orgID int64, patientID int64, beforeDate int64) (*models.MonitoringRecord, error) {
	var record models.MonitoringRecord
	err := readDb.Model(&models.MonitoringRecord{}).Where("patient_id = ? and user_org_id = ? and status = 1 and monitoring_date = ?", patientID, orgID, beforeDate).Order("operate_time desc").First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 透后评估
func MobileGetAssessmentAfterDislysis(orgID int64, patientID int64, recordDate int64) (*models.AssessmentAfterDislysis, error) {
	var record models.AssessmentAfterDislysis
	err := readDb.Model(&models.AssessmentAfterDislysis{}).Where("patient_id = ? and user_org_id = ? and status = 1 and assessment_date = ?", patientID, orgID, recordDate).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 获取 maxDate 之前一次的透后评估记录
func MobileGetLastTimeAssessmentAfterDislysis(orgID int64, patientID int64, maxDate int64) (*models.AssessmentAfterDislysis, error) {
	var record models.AssessmentAfterDislysis
	err := readDb.Model(&models.AssessmentAfterDislysis{}).Where("patient_id = ? and user_org_id = ? and status = 1 and assessment_date < ?", patientID, orgID, maxDate).Order("assessment_date desc").First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}
func MobileGetLast(orgID int64, patientID int64, maxDate int64) (models.AssessmentAfterDislysis, error) {
	dislysis := models.AssessmentAfterDislysis{}
	err := readDb.Model(&models.AssessmentAfterDislysis{}).Where("patient_id = ? and user_org_id = ? and status = 1 and assessment_date < ?", patientID, orgID, maxDate).Order("assessment_date desc").First(&dislysis).Error
	return dislysis, err
}

// 治疗小结
func MobileGetTreatmentSummary(orgID int64, patientID int64, recordDate int64) (*models.TreatmentSummary, error) {
	var record models.TreatmentSummary
	err := readDb.Model(&models.TreatmentSummary{}).Where("patient_id = ? and user_org_id = ? and status = 1 and assessment_date = ?", patientID, orgID, recordDate).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 透析处方
func MobileGetDialysisPrescribe(orgID int64, patientID int64, recordDate int64) (*models.DialysisPrescription, error) {
	var record models.DialysisPrescription
	err := readDb.Model(&models.DialysisPrescription{}).Where("patient_id = ? and user_org_id = ? and status = 1 and record_date = ?", patientID, orgID, recordDate).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 透析方案
func MobileGetDialysisSolution(orgID int64, patientID int64) (*models.DialysisSolution, error) {
	var record models.DialysisSolution
	err := readDb.Model(&models.DialysisSolution{}).Where("patient_id = ? and user_org_id = ? and status = 1", patientID, orgID).Last(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

func MobileGetPatientById(orgID int64, patientID int64) (*models.Patients, error) {
	var patient models.Patients
	err := readDb.Model(&models.Patients{}).Where("id = ? and user_org_id = ? and status = 1", patientID, orgID).First(&patient).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &patient, nil
}

func DisableMonitor(orgID int64, patientID int64, recordID int64, admin_user_id int64) error {
	fmt.Println()
	tx := writeDb.Begin()
	updateTime := time.Now().Unix()
	err := tx.Model(&models.MonitoringRecord{}).Where("user_org_id = ? AND patient_id = ? AND id = ? AND status = 1 ", orgID, patientID, recordID).Updates(map[string]interface{}{"status": 0, "updated_time": updateTime, "modify": admin_user_id}).Error
	if err != nil {
		tx.Rollback()
		return err
	}
	tx.Commit()
	return nil
}
func GetMonitor(orgID int64, patientID int64, id int64) (*models.MonitoringRecord, error) {
	var monitor models.MonitoringRecord
	var err error
	err = readDb.Model(&models.MonitoringRecord{}).Where("id = ? AND user_org_id = ? AND patient_id = ? AND status = 1 ", id, orgID, patientID).Find(&monitor).Error

	if err == gorm.ErrRecordNotFound {
		return nil, nil
	}

	if err != nil {
		return nil, err
	}
	return &monitor, nil
}

type MScheduleDoctorAdviceVM struct {
	ID           int64 `gorm:"column:id" json:"id"`
	UserOrgId    int64 `gorm:"column:user_org_id" json:"user_org_id"`
	PartitionId  int64 `gorm:"column:partition_id" json:"partition_id"`
	BedId        int64 `gorm:"column:bed_id" json:"bed_id"`
	PatientId    int64 `gorm:"column:patient_id" json:"patient_id"`
	ScheduleDate int64 `gorm:"column:schedule_date" json:"schedule_date"`
	ScheduleType int64 `gorm:"column:schedule_type" json:"schedule_type"`
	ModeId       int64 `gorm:"column:mode_id" json:"mode_id"`
	Status       int64 `gorm:"column:status" json:"status"`

	DialysisOrder   *MDialysisOrderVM   `gorm:"ForeignKey:DialysisDate,PatientId;AssociationForeignKey:ScheduleDate,PatientId" json:"dialysis_order"`
	SchedualPatient *MSchedualPatientVM `gorm:"ForeignKey:PatientId;AssociationForeignKey:ID" json:"patient"`
	DeviceNumber    *MDeviceNumberVM    `gorm:"ForeignKey:BedId" json:"device_number"`
	DoctorAdvices   []*MDoctorAdviceVM  `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"doctor_advice"`
}

func (MScheduleDoctorAdviceVM) TableName() string {
	return "xt_schedule"
}

type MDoctorAdviceVM struct {
	ID                    int64   `gorm:"column:id" json:"id"`
	UserOrgId             int64   `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId             int64   `gorm:"column:patient_id" json:"patient_id"`
	AdviceType            int64   `gorm:"column:advice_type" json:"advice_type"`
	AdviceDate            int64   `gorm:"column:advice_date" json:"advice_date"`
	StartTime             int64   `gorm:"column:start_time" json:"start_time"`
	AdviceName            string  `gorm:"column:advice_name" json:"advice_name"`
	AdviceDesc            string  `gorm:"column:advice_desc" json:"advice_desc"`
	ReminderDate          int64   `gorm:"column:reminder_date" json:"reminder_date"`
	SingleDose            float64 `gorm:"column:single_dose" json:"single_dose"`
	SingleDoseUnit        string  `gorm:"column:single_dose_unit" json:"single_dose_unit"`
	PrescribingNumber     float64 `gorm:"column:prescribing_number" json:"prescribing_number"`
	PrescribingNumberUnit string  `gorm:"column:prescribing_number_unit" json:"prescribing_number_unit"`
	DeliveryWay           string  `gorm:"column:delivery_way" json:"delivery_way"`
	ExecutionFrequency    string  `gorm:"column:execution_frequency" json:"execution_frequency"`
	AdviceDoctor          int64   `gorm:"column:advice_doctor" json:"advice_doctor"`
	Status                int64   `gorm:"column:status" json:"status"`
	CreatedTime           int64   `gorm:"column:created_time" json:"created_time"`
	UpdatedTime           int64   `gorm:"column:updated_time" json:"updated_time"`
	AdviceAffirm          string  `gorm:"column:advice_affirm" json:"advice_affirm"`
	Remark                string  `gorm:"column:remark" json:"remark"`
	StopTime              int64   `gorm:"column:stop_time" json:"stop_time"`
	StopReason            string  `gorm:"column:stop_reason" json:"stop_reason"`
	StopDoctor            int64   `gorm:"column:stop_doctor" json:"stop_doctor"`
	StopState             int64   `gorm:"column:stop_state" json:"stop_state"`
	ParentId              int64   `gorm:"column:parent_id" json:"parent_id"`
	ExecutionTime         int64   `gorm:"column:execution_time" json:"execution_time"`
	ExecutionStaff        int64   `gorm:"column:execution_staff" json:"execution_staff"`
	ExecutionState        int64   `gorm:"column:execution_state" json:"execution_state"`
	Checker               int64   `gorm:"column:checker" json:"checker"`
	RecordDate            int64   `gorm:"column:record_date" json:"record_date"`
	DialysisOrderId       int64   `gorm:"column:dialysis_order_id" json:"dialysis_order_id"`
	CheckTime             int64   `gorm:"column:check_time" json:"check_time"`
	CheckState            int64   `gorm:"column:check_state" json:"check_state"`
	DrugSpec              float64 `gorm:"column:drug_spec" json:"drug_spec"`
	DrugSpecUnit          string  `gorm:"column:drug_spec_unit" json:"drug_spec_unit"`
	Groupno               int64   `gorm:"column:groupno" json:"groupno"`
	RemindType            int64   `gorm:"column:remind_type" json:"remind_type"`
	FrequencyType         int64   `gorm:"column:frequency_type" json:"frequency_type"`
	DayCount              int64   `gorm:"column:day_count" json:"day_count"`
	WeekDay               string  `gorm:"column:week_day" json:"week_day"`
	TemplateId            string  `gorm:"column:template_id" json:"template_id"`
	Modifier              int64   `gorm:"column:modifier" json:"modifier" form:"modifier"`
}

func (MDoctorAdviceVM) TableName() string {
	return "xt_doctor_advice"
}

func MobileGetScheduleDoctorAdvices(orgID int64, scheduleDate int64, adviceType int, patientType int, adminUserId int64) ([]*MScheduleDoctorAdviceVM, error) {
	var vms []*MScheduleDoctorAdviceVM
	adviceWhere := ""
	adviceCondition := []interface{}{}
	if adviceType == 0 {
		if patientType == 0 {
			adviceWhere = "status = 1 AND user_org_id = ? AND record_date = ? AND (advice_type = 3 OR advice_type = 1)"
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate)

		} else if patientType == 1 {
			adviceWhere = "status = 1 AND user_org_id = ? AND record_date = ? AND advice_doctor = ? AND(advice_type = 3 OR advice_type = 1)"
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate, adminUserId)

		} else if patientType == 2 {
			adviceWhere = "status = 1 AND user_org_id = ? AND record_date = ? AND execution_staff = 0 AND(advice_type = 3 OR advice_type = 1)"
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate)
		}

	} else if adviceType == 1 {
		if patientType == 0 {
			adviceWhere = "status = 1 AND user_org_id = ? AND advice_type = 1 AND record_date = ?  "
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate)

		} else if patientType == 1 {
			adviceWhere = "status = 1 AND user_org_id = ? AND advice_type = 1 AND record_date = ? AND advice_doctor = ? "
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate, adminUserId)

		} else if patientType == 2 {
			adviceWhere = "status = 1 AND user_org_id = ? AND advice_type = 1 AND record_date = ? AND execution_staff = 0"
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate)

		}

	} else if adviceType == 3 {
		if patientType == 0 {
			adviceWhere = "status = 1 AND user_org_id = ? AND advice_type = 3 AND record_date = ?  "
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate)

		} else if patientType == 1 {
			adviceWhere = "status = 1 AND user_org_id = ? AND record_date = ? AND advice_type = 3 AND advice_doctor = ? "
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate, adminUserId)
		} else if patientType == 2 {
			adviceWhere = "status = 1 AND user_org_id = ? AND record_date = ? AND advice_type = 3  AND execution_staff = 0"
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate)
		}

	} else if adviceType == 2 {
		if patientType == 0 {
			adviceWhere = "status = 1 AND user_org_id = ? AND advice_type = 2 AND record_date = ?  "
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate)

		} else if patientType == 1 {
			adviceWhere = "status = 1 AND user_org_id = ? AND record_date = ? AND advice_type = 2 AND advice_doctor = ? "
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate, adminUserId)
		} else if patientType == 2 {
			adviceWhere = "status = 1 AND user_org_id = ? AND record_date = ? AND advice_type = 2  AND execution_staff = 0"
			adviceCondition = append(adviceCondition, adviceWhere, orgID, scheduleDate)
		}

	}

	db := readDb.
		Table("xt_schedule").
		Preload("SchedualPatient", "status = 1 AND user_org_id = ?", orgID).
		Preload("DialysisOrder", func(db *gorm.DB) *gorm.DB {
			return db.Where("status = 1 AND user_org_id = ?", orgID).Preload("DeviceNumber", "status = 1 AND org_id= ?", orgID)
		}).
		Preload("DeviceNumber", "status = 1 AND org_id = ?", orgID).
		Preload("DeviceNumber.Zone", "status = 1 AND org_id = ?", orgID).
		Preload("DoctorAdvices", adviceCondition...).
		Where("status = 1 AND user_org_id = ?", orgID)
	if scheduleDate != 0 {
		db = db.Where("schedule_date = ?", scheduleDate)
	}

	err := db.Find(&vms).Error
	return vms, err
}

func MobileCreateDialysisOrder(orgID int64, patientID int64, order *models.DialysisOrder) error {
	now := time.Now()
	tx := writeDb.Begin()
	if createOrderErr := tx.Model(&models.DialysisOrder{}).Create(order).Error; createOrderErr != nil {
		tx.Rollback()
		return createOrderErr
	}

	// 更新透析记录 ID
	// 透析处方
	if err := tx.Model(&models.DialysisPrescription{}).Where("user_org_id = ? AND patient_id = ? AND record_date = ? AND status = 1", orgID, patientID, order.DialysisDate).Updates(map[string]interface{}{"record_id": order.ID, "updated_time": now.Unix()}).Error; err != nil {
		tx.Rollback()
		return err
	}

	// 接诊评估
	if err := tx.Model(&models.ReceiveTreatmentAsses{}).Where("user_org_id = ? AND patient_id = ? AND record_date = ? AND status = 1", orgID, patientID, order.DialysisDate).Updates(map[string]interface{}{"record_id": order.ID, "updated_time": now.Unix()}).Error; err != nil {
		tx.Rollback()
		return err
	}

	// 透前评估
	if err := tx.Model(&models.PredialysisEvaluation{}).Where("user_org_id = ? AND patient_id = ? AND assessment_date = ? AND status = 1", orgID, patientID, order.DialysisDate).Updates(map[string]interface{}{"dialysis_order_id": order.ID, "updated_time": now.Unix()}).Error; err != nil {
		tx.Rollback()
		return err
	}

	// 临时医嘱
	if err := tx.Model(&models.DoctorAdvice{}).Where("user_org_id = ? AND patient_id = ? AND record_date = ? AND status = 1 AND advice_type = 2", orgID, patientID, order.DialysisDate).Updates(map[string]interface{}{"dialysis_order_id": order.ID, "updated_time": now.Unix()}).Error; err != nil {
		tx.Rollback()
		return err
	}

	// 双人核对
	if err := tx.Model(&models.DoubleCheck{}).Where("user_org_id = ? AND patient_id = ? AND check_date = ? AND status = 1", orgID, patientID, order.DialysisDate).Updates(map[string]interface{}{"dialysis_order_id": order.ID, "updated_time": now.Unix()}).Error; err != nil {
		tx.Rollback()
		return err
	}

	// 透后评估
	if err := tx.Model(&models.AssessmentAfterDislysis{}).Where("user_org_id = ? AND patient_id = ? AND assessment_date = ? AND status = 1", orgID, patientID, order.DialysisDate).Updates(map[string]interface{}{"dialysis_order_id": order.ID, "updated_time": now.Unix()}).Error; err != nil {
		tx.Rollback()
		return err
	}

	// 治疗小结
	if err := tx.Model(&models.TreatmentSummary{}).Where("user_org_id = ? AND patient_id = ? AND assessment_date = ? AND status = 1", orgID, patientID, order.DialysisDate).Updates(map[string]interface{}{"dialysis_order_id": order.ID, "updated_time": now.Unix()}).Error; err != nil {
		tx.Rollback()
		return err
	}

	// 透析监测
	if err := tx.Model(&models.MonitoringRecord{}).Where("patient_id = ? and user_org_id=? and status=1 and monitoring_date = ?", patientID, orgID, order.DialysisDate).Update(map[string]interface{}{"dialysis_order_id": order.ID, "updated_time": now.Unix()}).Error; err != nil {
		tx.Rollback()
		return err
	}

	tx.Commit()
	return nil
}

type MobileUrgentSchedulePatientVM struct {
	ID         int64  `gorm:"column:id" json:"id"`
	Name       string `gorm:"column:name" json:"name"`
	DialysisNo string `gorm:"column:dialysis_no" json:"dialysis_no"`
}

func (MobileUrgentSchedulePatientVM) TableName() string {
	return "xt_patients"
}

type MobileUrgentScheduleTreatmentModeVM struct {
	ID   int64  `gorm:"column:id" json:"id"`
	Name string `gorm:"column:name" json:"name"`
}

func (MobileUrgentScheduleTreatmentModeVM) TableName() string {
	return "xt_treatment_mode"
}

func MobileGetAllPatientsForUrgentSchedule(orgID int64, record_date int64) ([]*MobileUrgentSchedulePatientVM, error) {
	var vms []*MobileUrgentSchedulePatientVM = make([]*MobileUrgentSchedulePatientVM, 0)
	rows, err := readDb.Raw("SELECT p.*  FROM xt_patients as p  WHERE (p.user_org_id = ? AND p.status = 1 AND p.lapseto = 1) AND NOT EXISTS (Select * FROM `xt_dialysis_order` as d Where d.`dialysis_date` = ? AND d.`status` = 1 AND d.`patient_id` = p.id AND  d.user_org_id = p.user_org_id  )", orgID, record_date).Rows()
	defer rows.Close()
	if err != nil {
		return nil, err
	}
	for rows.Next() {
		var vm MobileUrgentSchedulePatientVM
		readDb.ScanRows(rows, &vm)
		vms = append(vms, &vm)
	}
	return vms, nil
}

func MobileGetAllTrearmentModesForUrgentSchedule() ([]*MobileUrgentScheduleTreatmentModeVM, error) {
	var modes []*MobileUrgentScheduleTreatmentModeVM
	err := readDb.Model(&MobileUrgentScheduleTreatmentModeVM{}).Where("status = 1").Find(&modes).Error
	if err != nil {
		return nil, err
	}
	return modes, nil
}

type MobileUrgentScheduleScheduleListVM struct {
	ID int64 `gorm:"column:id" json:"id"`
	// ZoneID    int64 `gorm:"column:partition_id" json:"zone_id"`
	DeviceNumberID int64 `gorm:"column:bed_id" json:"bed_id"`
	PatientID      int64 `gorm:"column:patient_id" json:"patient_id"`
	ScheduleType   int   `gorm:"column:schedule_type" json:"schedule_type"`

	DeviceNumber *models.DeviceNumber `gorm:"ForeignKey:DeviceNumberID" json:"device_number"`
	// DeviceZone   *models.DeviceZone   `gorm:"ForeignKey:ZoneID" json:"device_zone"`
}

func (MobileUrgentScheduleScheduleListVM) TableName() string {
	return "xt_schedule"
}

func MobileGetSchedulesForUrgentSchedule(orgID int64, scheduleDate int64, schedule_type int) (schedules []*MobileUrgentScheduleScheduleListVM, err error) {
	db := readDb.
		Model(&MobileUrgentScheduleScheduleListVM{}).
		Preload("DeviceNumber", "status = 1 AND org_id = ?", orgID).
		Where("status = 1 AND user_org_id = ? AND schedule_date = ? AND schedule_type = ? ", orgID, scheduleDate, schedule_type)
	err = db.Find(&schedules).Error
	if err != nil {
		return nil, err
	}
	return schedules, nil

}

func MobileGetOtherSchedulesForUrgentSchedule(orgID int64, scheduleDate int64, schedule_type int) ([]*MobileUrgentScheduleScheduleListVM, error) {
	var vms []*MobileUrgentScheduleScheduleListVM = make([]*MobileUrgentScheduleScheduleListVM, 0)
	rows, err := readDb.Raw("SELECT * FROM xt_schedule as s WHERE s.user_org_id = ? AND s.status = 1 AND s.schedule_date = ? ", orgID, scheduleDate).Rows()
	defer rows.Close()
	if err != nil {
		return nil, err
	}
	for rows.Next() {
		var vm MobileUrgentScheduleScheduleListVM
		readDb.ScanRows(rows, &vm)
		vms = append(vms, &vm)
	}
	return vms, nil

}

type MobileUrgentScheduleDeviceNumberVM struct {
	ID     int64  `gorm:"column:id" json:"id"`
	Number string `gorm:"column:number" json:"number"`
	ZoneID int64  `gorm:"column:zone_id" json:"zone_id"`

	Zone *models.DeviceZone `gorm:"ForeignKey:ZoneID" json:"zone"`
}

func (MobileUrgentScheduleDeviceNumberVM) TableName() string {
	return "xt_device_number"
}

func MobileGetAllDeviceNumbersForUrgentSchedule(orgID int64, record_date int64, schedule_type int) ([]*DeviceNumberViewModel, error) {

	var vms []*DeviceNumberViewModel = make([]*DeviceNumberViewModel, 0)
	rows, err := readDb.Raw("SELECT n.*, z.name as zone_name, g.name as group_name FROM xt_device_number as n join xt_device_zone as z on z.id = n.zone_id join xt_device_group as g on g.id = n.group_id  WHERE (n.org_id = ? AND n.status = 1) AND NOT EXISTS (Select * FROM xt_schedule as s Where s.`schedule_date` = ?  AND  s.user_org_id = n.org_id AND s.`bed_id` = n.id  AND s.`schedule_type` = ? AND s.status = 1 )", orgID, record_date, schedule_type).Rows()
	defer rows.Close()
	if err != nil {
		return nil, err
	}
	for rows.Next() {
		var vm DeviceNumberViewModel
		readDb.ScanRows(rows, &vm)
		vms = append(vms, &vm)
	}
	return vms, nil

	//var deviceNumbers []*MobileUrgentScheduleDeviceNumberVM
	//db := readDb.
	//	Model(&MobileUrgentScheduleDeviceNumberVM{}).
	//	Preload("Zone", "status = 1 AND org_id = ?", orgID).
	//	Where("status = 1 AND org_id = ?", orgID)
	//err := db.Order("zone_id asc").Find(&deviceNumbers).Error
	//if err != nil {
	//	return nil, err
	//}
	//return deviceNumbers, nil
}

func GetValidScheduleMonitorRecordCount() (int64, error) {
	var total int64
	err := readDb.Model(&models.MonitoringRecord{}).Where("status = 1 AND operate_time = 0 AND monitoring_date <> 0").Count(&total).Error
	return total, err
}

func GetTop1000ValidScheduleMonitorRecord() ([]*models.MonitoringRecord, error) {
	var monitors []*models.MonitoringRecord
	err := readDb.Model(&models.MonitoringRecord{}).Where("status = 1 AND operate_time = 0 AND monitoring_date <> 0").Order("id asc").Limit(100).Find(&monitors).Error
	if err != nil {
		return nil, err
	}
	return monitors, nil
}

func BatchUpdateMonitors(monitors []*models.MonitoringRecord) error {
	tx := writeDb.Begin()
	for index := 0; index < len(monitors); index++ {
		tx.Save(monitors[index])
	}
	return tx.Commit().Error
}

func ModifyStartDialysisOrder(order *models.DialysisOrder) error {
	tx := writeDb.Begin()
	updateTime := time.Now().Unix()
	err := tx.Model(&models.DialysisOrder{}).Where("user_org_id = ? AND id = ? AND status = 1 ", order.UserOrgId, order.ID).Updates(map[string]interface{}{"start_nurse": order.StartNurse, "updated_time": updateTime, "bed_id": order.BedID, "puncture_nurse": order.PunctureNurse, "start_time": order.StartTime, "modifier": order.Modifier, "schedual_type": order.SchedualType}).Error
	if err != nil {
		tx.Rollback()
		return err
	}
	tx.Commit()
	return err
}

func ModifyFinishDialysisOrder(order *models.DialysisOrder) error {
	tx := writeDb.Begin()
	updateTime := time.Now().Unix()
	err := tx.Model(&models.DialysisOrder{}).Where("user_org_id = ? AND id = ? AND status = 1 ", order.UserOrgId, order.ID).Updates(map[string]interface{}{"finish_nurse": order.FinishNurse, "updated_time": updateTime, "end_time": order.EndTime, "finish_modifier": order.FinishModifier}).Error
	if err != nil {
		tx.Rollback()
		return err
	}
	tx.Commit()
	return err
}

func MobileGetLastDryWeight(orgID int64, patientID int64) (*models.SgjPatientDryweight, error) {
	var record models.SgjPatientDryweight
	err := readDb.Model(&models.SgjPatientDryweight{}).Where("patient_id = ? and user_org_id = ? and status = 1", patientID, orgID).Last(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 透析方案
func MobileGetDialysisSolutionByModeId(orgID int64, patientID int64, mode_id int64) (*models.DialysisSolution, error) {
	var record models.DialysisSolution
	err := readDb.Model(&models.DialysisSolution{}).Where("patient_id = ? and user_org_id = ? and status = 1 AND mode_id = ?", patientID, orgID, mode_id).Last(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 透析处方
func MobileGetDialysisPrescribeByModeId(orgID int64, patientID int64, recordDate int64, mode_id int64) (*models.DialysisPrescription, error) {
	var record models.DialysisPrescription
	err := readDb.Model(&models.DialysisPrescription{}).Where("patient_id = ? and user_org_id = ? and status = 1 and record_date = ? AND mode_id = ?", patientID, orgID, recordDate, mode_id).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

func MobileGetLastDialysisPrescribe(orgID int64, patientID int64) (*models.DialysisPrescription, error) {
	var record models.DialysisPrescription
	err := readDb.Model(&models.DialysisPrescription{}).Where("patient_id = ? and user_org_id = ? and status = 1 ", patientID, orgID).Last(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

func MobileGetLastDialysisPrescribeByModeId(orgID int64, patientID int64, mode_id int64) (*models.DialysisPrescription, error) {
	var record models.DialysisPrescription
	err := readDb.Model(&models.DialysisPrescription{}).Where("patient_id = ? and user_org_id = ? and status = 1  AND mode_id = ?", patientID, orgID, mode_id).Last(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

func GetAllAvaildDeviceNumbers(orgID int64, record_date int64, schedule_type int) ([]*DeviceNumberViewModel, error) {
	var vms []*DeviceNumberViewModel = make([]*DeviceNumberViewModel, 0)
	rows, err := readDb.Raw("SELECT n.*, z.name as zone_name, g.name as group_name FROM xt_device_number as n join xt_device_zone as z on z.id = n.zone_id join xt_device_group as g on g.id = n.group_id  WHERE (n.org_id = ? AND n.status = 1) AND NOT EXISTS (Select * FROM xt_schedule as s Where s.`schedule_date` = ?  AND  s.user_org_id = n.org_id AND s.`bed_id` = n.id  AND s.`schedule_type` = ? AND s.status = 1 )", orgID, record_date, schedule_type).Rows()
	defer rows.Close()
	if err != nil {
		return nil, err
	}
	for rows.Next() {
		var vm DeviceNumberViewModel
		readDb.ScanRows(rows, &vm)
		vms = append(vms, &vm)
	}
	return vms, nil
}

// 获取 maxDate 之前一次的透前评估记录
func GetLastTimePredialysisEvaluation(orgID int64, patientID int64, maxDate int64) (*models.PredialysisEvaluation, error) {
	var record models.PredialysisEvaluation
	err := readDb.Model(&models.PredialysisEvaluation{}).Where("patient_id = ? and user_org_id = ? and status = 1 and assessment_date < ?", patientID, orgID, maxDate).Order("assessment_date desc").First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

func GetLastMonitorRecord(orgID int64, patientID int64, beforeDate int64) (*models.MonitoringRecord, error) {
	var record models.MonitoringRecord
	err := readDb.Model(&models.MonitoringRecord{}).Where("patient_id = ? and user_org_id = ? and status = 1 and monitoring_date = ?", patientID, orgID, beforeDate).Order("operate_time desc").First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 获取 maxDate 之前一次的透后评估记录
func GetLastTimeAssessmentAfterDislysis(orgID int64, patientID int64, maxDate int64) (*models.AssessmentAfterDislysis, error) {
	var record models.AssessmentAfterDislysis
	err := readDb.Model(&models.AssessmentAfterDislysis{}).Where("patient_id = ? and user_org_id = ? and status = 1 and assessment_date < ?", patientID, orgID, maxDate).Order("assessment_date desc").First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 透析处方
func GetDialysisPrescribe(orgID int64, patientID int64, recordDate int64) (*models.DialysisPrescription, error) {
	var record models.DialysisPrescription
	err := readDb.Model(&models.DialysisPrescription{}).Where("patient_id = ? and user_org_id = ? and status = 1 and record_date = ?", patientID, orgID, recordDate).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

// 透析方案
func GetDialysisSolution(orgID int64, patientID int64, mode_id int64) (*models.DialysisSolution, error) {
	var record models.DialysisSolution
	err := readDb.Model(&models.DialysisSolution{}).Where("patient_id = ? and user_org_id = ? and status = 1 AND mode_id = ?", patientID, orgID, mode_id).Last(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

func GetLastDialysisPrescribeByModeId(orgID int64, patientID int64, mode_id int64) (*models.DialysisPrescription, error) {
	var record models.DialysisPrescription
	err := readDb.Model(&models.DialysisPrescription{}).Where("patient_id = ? and user_org_id = ? and status = 1  AND mode_id = ?", patientID, orgID, mode_id).Last(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

func GetLastDryWeight(orgID int64, patientID int64) (*models.SgjPatientDryweight, error) {
	var record models.SgjPatientDryweight
	err := readDb.Model(&models.SgjPatientDryweight{}).Where("patient_id = ? and user_org_id = ? and status = 1", patientID, orgID).Last(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

func MobileGetSystemDialysisPrescribeByModeId(orgID int64, mode_id int64) (*models.SystemPrescription, error) {
	var record models.SystemPrescription
	err := readDb.Model(&models.SystemPrescription{}).Where("user_org_id = ? and status = 1  AND mode_id = ?", orgID, mode_id).First(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}

func GetSystemDialysisPrescribeByModeId(orgID int64, mode_id int64) (*models.SystemPrescription, error) {
	var record models.SystemPrescription
	err := readDb.Model(&models.SystemPrescription{}).Where("user_org_id = ? and status = 1  AND mode_id = ?", orgID, mode_id).Last(&record).Error
	if err != nil {
		if err == gorm.ErrRecordNotFound {
			return nil, nil
		} else {
			return nil, err
		}
	}
	return &record, nil
}
